#########################################################################
### SDC ENCRYPTOR - Tool for encryption
#########################################################################
### v. 1.0 GUI edition
#########################################################################
### Copyright 2010 Eero Karvonen (Sharp Dis-Chord)
#########################################################################
''' This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.'''
#########################################################################

import sys
from Tkinter import *
import tkFileDialog
import tkSimpleDialog
import tkMessageBox

def exit_program():
    sys.exit()
    
def info():
    tkMessageBox.showinfo("Info!", "GUI edition for the Sharp Dis-Chord Encryptor 1.0\nCopyright 2010 Eero Karvonen (SDC).\nA simple tool to encrypt and decrypt any files with a password.\nDon't use spaces in the passwords, or the files will be corrupt!")

def encrypted(filename):
    name = filename+".sdce"
    tkMessageBox.showinfo(
            "Encryption done!",
            "Encrypted the file to:\n(%s)." % name)
            
def decrypted(filename):
    name = filename[:-5]
    tkMessageBox.showinfo(
            "Decryption done!",
            "Decrypted the file to:\n(%s)." % name)  

def encrypt(filename, password):
    try:
        file = open(filename, "rb")
        data = file.read()
    except:
        print "ERROR: The file specified doesn't exist! Exiting..."
        sys.exit()
        
    key = password
        
    string = ""
    # Load the data into array
    l = len(data)
    x = 100
    c = 1
    last_percent = 0
    c_key = 0
    
    for b in data:
        # Modifications to b
        delta_b = ord(b) + ord(key[c_key])
        if delta_b > 255:
            string += chr(delta_b - 256)
        else:
            string += chr(delta_b)

        c_key += 1
        if c_key == len(key):
            c_key = 0
        
        if x == 0:
            percent = int(float(c)/float(l)*100)+1
            if percent != last_percent:
                print "Encrypting the file "+filename+": "+str(percent)+" %."
                last_percent = percent
            x = 100
        x -= 1
        c += 1

    outfile = open(filename+".sdce", "wb")
    outfile.write(string)
    outfile.close()
    print "Written the encrypted file to "+filename+".sdce."

def decrypt(filename, password):
    try:
        file = open(filename, "rb")
        data = file.read()
    except:
        print "ERROR: The file specified doesn't exist! Exiting..."
        sys.exit()
        
    if filename[-5:] != ".sdce":
        print "ERROR: The file doesn't seem to have the correct *.sdce suffix."
        print "Exiting..."
        sys.exit()
        
    key = password
    
    string = ""
    # Load the data into array
    l = len(data)
    x = 100
    c = 1
    last_percent = 0
    c_key = 0
    
    for b in data:
        # Modifications to b
        delta_b = ord(b) - ord(key[c_key])
        if delta_b < 0:
            string += chr(delta_b + 256)
        else:
            string += chr(delta_b)

        c_key += 1
        if c_key == len(key):
            c_key = 0
        
        if x == 0:
            percent = int(float(c)/float(l)*100)+1
            if percent != last_percent:
                print "Decrypting the file "+filename+": "+str(percent)+" %."
                last_percent = percent
            x = 100
        x -= 1
        c += 1
        
    outfile = open(filename[:-5], "wb")
    outfile.write(string)
    outfile.close()
    print "Written the decrypted file to "+filename[:-5]+"." 
    
def select_to_encrypt():
    filename = ""
    filename = tkFileDialog.askopenfilename(parent=root, filetypes=[('All sorts of files', '*.*')], title="Select the file you want to encrypt.")
    if filename == () or filename == "": return
    password = tkSimpleDialog.askstring("Password and Encrypt.", [])
    if password == "": return
    encrypt(filename, password)
    encrypted(filename)
    
def select_to_decrypt():
    filename = tkFileDialog.askopenfilename(parent=root, filetypes=[('Sharp Dis-Chord Encrypted Files', '.sdce')]
, title="Select the file you want to decrypt.")
    if filename == () or filename == "": return
    password = tkSimpleDialog.askstring("Password and Decrypt.", [])
    if password == "": return
    decrypt(filename, password)
    decrypted(filename)
        
root = Tk()
root.geometry("%dx%d%+d%+d" % (400, 60, 300, 300))
root.title("Sharp Dis-Chord Encryptor 1.0 GUI")
root.resizable(False,False)

w = Label(root, text="Click to the menu above.")
w.pack()

menu = Menu(root)
filemenu = Menu(menu)
root.config(menu=menu)
menu.add_cascade(label="File to...", menu=filemenu)
filemenu.add_command(label="Encrypt", command=select_to_encrypt)
filemenu.add_command(label="Decrypt", command=select_to_decrypt)
filemenu.add_separator()
filemenu.add_command(label="Info!", command=info)
filemenu.add_command(label="Exit Program", command=exit_program)

root.mainloop()

sys.exit()
