#########################################################################
### SDC ENCRYPTOR - Tool for encryption
#########################################################################
### v. 1.0 command line edition
#########################################################################
### Copyright 2010 Eero Karvonen (Sharp Dis-Chord)
#########################################################################
''' This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.'''
#########################################################################

import sys

print "###########################################"
print "### SDC ENCRYPTOR - Tool for encryption ###"
print "###########################################"
print "### v. 1.0 commandline edition          ###"
print "###########################################"
print "### Copyright 2010 Eero Karvonen (SDC)  ###"
print "###########################################"
if len(sys.argv) < 2:
    print "Argument 'e' stands for encryption and 'd' for decryption."
    print "You can also type the filename and password straight as the second and the third arguments."
    print "Exiting..."
    sys.exit()
if sys.argv[1] == "e": MODE = "encrypt"
elif sys.argv[1] == "d": MODE = "decrypt"
elif sys.argv[1] == "help":
    print "HELP: Argument 'e' stands for encryption and 'd' for decryption."
if len(sys.argv) == 3:
    print "ERROR: You were supposed to give the password as the third argument. Exiting..."
    sys.exit()
if len(sys.argv) == 4:
    fname = sys.argv[2]
    pw = sys.argv[3]
    longway = 0
else:
    fname = None
    pw = None
    longway = 1

print "Selected mode is "+MODE
if longway == 1:
    filename = raw_input("[Type the name of the file to "+MODE+"]>>")
    key = raw_input("[Type the password to "+MODE+" it with]>>")
else:
    filename = fname
    key = pw
    
# ENCRYPT
if MODE == "encrypt":
    try:
        file = open(filename, "rb")
        data = file.read()
    except:
        print "ERROR: The file specified doesn't exist! Exiting..."
        sys.exit()
        
    string = ""
    # Load the data into array
    l = len(data)
    x = 100
    c = 1
    last_percent = 0
    c_key = 0
    
    for b in data:
        # Modifications to b
        delta_b = ord(b) + ord(key[c_key])
        if delta_b > 255:
            string += chr(delta_b - 256)
        else:
            string += chr(delta_b)

        c_key += 1
        if c_key == len(key):
            c_key = 0
        
        if x == 0:
            percent = int(float(c)/float(l)*100)+1
            if percent != last_percent:
                print "Encrypting the file "+filename+": "+str(percent)+" %."
                last_percent = percent
            x = 100
        x -= 1
        c += 1


    outfile = open(filename+".sdce", "wb")
    outfile.write(string)
    outfile.close()
    print "Written the encrypted file to "+filename+".sdce."

# DECRYPT
if MODE == "decrypt":
    try:
        file = open(filename, "rb")
        data = file.read()
    except:
        print "ERROR: The file specified doesn't exist! Exiting..."
        sys.exit()
        
    if filename[-5:] != ".sdce":
        print "ERROR: The file doesn't seem to have the correct *.sdce suffix."
        print "Exiting..."
        sys.exit()
        
    string = ""
    # Load the data into array
    l = len(data)
    x = 100
    c = 1
    last_percent = 0
    c_key = 0
    
    for b in data:
        # Modifications to b
        delta_b = ord(b) - ord(key[c_key])
        if delta_b < 0:
            string += chr(delta_b + 256)
        else:
            string += chr(delta_b)

        c_key += 1
        if c_key == len(key):
            c_key = 0
        
        if x == 0:
            percent = int(float(c)/float(l)*100)+1
            if percent != last_percent:
                print "Decrypting the file "+filename+": "+str(percent)+" %."
                last_percent = percent
            x = 100
        x -= 1
        c += 1
        
    outfile = open(filename[:-5], "wb")
    outfile.write(string)
    outfile.close()
    print "Written the decrypted file to "+filename[:-5]+"."
    
sys.exit()

